<?php
/*************************************************************
*www.softiran.org
**************************************************************/

class osC_Payment_pas extends osC_Payment {
	var $_title, $_code = 'pas', $_status = false, $_sort_order, $_order_id;

	function osC_Payment_pas() {
		global $osC_Database, $osC_Language, $osC_ShoppingCart;
		$this->_title = $osC_Language->get('درگاه پرداخت الکترونیک سپهر');
		$this->_method_title = $osC_Language->get('درگاه پرداخت الکترونیک سپهر');
		$this->_status = (MODULE_PAYMENT_PAS_STATUS == '1') ? true : false;
		$this->_sort_order = MODULE_PAYMENT_PAS_SORT_ORDER;
		$this->form_action_url = 'https://mabna.shaparak.ir:8080';
		
		if ($this->_status === true) {
			if ((int) MODULE_PAYMENT_PAS_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_PAS_ORDER_STATUS_ID;
			}
			if ((int) MODULE_PAYMENT_PAS_ZONE > 0) {
				$check_flag = false;
				$Qcheck = $osC_Database->query('select zone_id from :table_zones_to_geo_zones where geo_zone_id = :geo_zone_id and zone_country_id = :zone_country_id order by zone_id');
				$Qcheck->bindTable(':table_zones_to_geo_zones', TABLE_ZONES_TO_GEO_ZONES);
				$Qcheck->bindInt(':geo_zone_id', MODULE_PAYMENT_PAS_ZONE);
				$Qcheck->bindInt(':zone_country_id', $osC_ShoppingCart->getBillingAddress('country_id'));
				$Qcheck->execute();
				while ($Qcheck->next()) {
					if ($Qcheck->valueInt('zone_id') < 1) {
						$check_flag = true;
						break;
					}
					elseif ($Qcheck->valueInt('zone_id') == $osC_ShoppingCart->getBillingAddress('zone_id')) {
						$check_flag = true;
						break;
					}
				}
				if ($check_flag === false) {
					$this->_status = false;
				}
			}
		}
	}
	function selection() {
		return array('id' => $this->_code, 'module' => $this->_method_title);
	}
	function pre_confirmation_check() {
		return false;
	}
	function confirmation() {
		global $osC_Language, $osC_CreditCard;
		$this->_order_id = osC_Order :: insert(ORDERS_STATUS_PREPARING);
		$confirmation = array('title' => $this->_method_title, 'fields' => array(array('title' => $osC_Language->get('درگاه شرکت پرداخت الکترونیک سپهر'))));
		return $confirmation;
	}
	function process_button() {
		global $osC_Currencies, $osC_ShoppingCart, $osC_Language, $osC_Database;
		if (MODULE_PAYMENT_PAS_CURRENCY == 'Selected Currency') {
			$currency = $osC_Currencies->getCode();
		}
		else {
			$currency = MODULE_PAYMENT_PAS_CURRENCY;
		}
		$amount = round($osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), $currency), 2);
		$order = $this->_order_id;
		$status = 1;
		$redirectAddress = (osc_href_link(FILENAME_CHECKOUT, 'process', 'HTTP', null, null, true));
		
		$terminal = trim(MODULE_PAYMENT_PAS_TER);
		
		
		
		$invoiceNumber = time();


		
		@session_start();
		$_SESSION['order'] =$order ;
		$params ='terminalID='.$terminal.'&Amount='.$amount.'&callbackURL='.urlencode($redirectAddress).'&invoiceID='.$invoiceNumber;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/GetToken');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$res = curl_exec($ch);
		curl_close($ch);
		if($res)
		{
			$res = json_decode($res,true);
			if($res['Status'] == '0')
			{	  
				$osC_Database->simpleQuery("insert into `" . DB_TABLE_PREFIX . "online_transactions`(orders_id,receipt_id,transaction_method,transaction_date,transaction_amount,transaction_id) values('$order','$invoiceNumber','pas','','$amount','')");
				$process_button_string .= osc_draw_hidden_field('TerminalID', $terminal);
				$process_button_string .= osc_draw_hidden_field('token', $res['Accesstoken']);
				return $process_button_string;
			}else
			{
				return ('خطا در ساخت توکن <br/> کد خطا :'.$res['Status']);
			}
		}
		else
		{
			return ('پورت 8081 در هاست شما بسته است !');
		}
		
		

	}
	function get_error() {
		global $osC_Language;
		return $error;
	}
	function process() 
	{
		global $osC_Language, $osC_Customer,$osC_Currencies, $osC_ShoppingCart, $_POST, $_GET, $messageStack, $osC_Database;
		@session_start();
		$invoiceid = isset($_SESSION['order']) ? $_SESSION['order'] : 0;
		$amount = round($osC_Currencies->formatRaw($osC_ShoppingCart->getTotal(), $currency), 2);

		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{

			
			
			$terminal = trim(MODULE_PAYMENT_PAS_TER);
		
			$referenceId = $_POST['digitalreceipt'];
			$Qtransaction = $osC_Database->query("select count(*) as total from `" . DB_TABLE_PREFIX . "online_transactions` where  transaction_id = :transaction_return_value ");
			$Qtransaction->bindValue(':transaction_return_value', $referenceId);
			$Qtransaction->execute();
			if ($Qtransaction->valueInt('total') <= 0)
			{
				$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
				curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
				$result = json_decode($res,true);
					
				if (strtoupper($result['Status']) == 'OK') 
				{ 
					 if( floatval($result['ReturnId']) == floatval($amount) )
					{
						$osC_Database->simpleQuery("update `" . DB_TABLE_PREFIX . "online_transactions` set transaction_id = '$referenceId',transaction_date = '" . date("YmdHis") . "' where  orders_id = '$invoiceid' ");
						$Qtransaction = $osC_Database->query('insert into :table_orders_transactions_history (orders_id, transaction_code, transaction_return_value, transaction_return_status, date_added) values (:orders_id, :transaction_code, :transaction_return_value, :transaction_return_status, now())');
						$Qtransaction->bindTable(':table_orders_transactions_history', TABLE_ORDERS_TRANSACTIONS_HISTORY);
						$Qtransaction->bindInt(':orders_id', $invoiceid);
						$Qtransaction->bindInt(':transaction_code', 1);
						$Qtransaction->bindValue(':transaction_return_value', $referenceId);
						$Qtransaction->bindInt(':transaction_return_status', 1);
						$Qtransaction->execute();
						$this->_order_id = osC_Order :: insert();
						$comments = $osC_Language->get(' کدارجاع : ') .$referenceId.'  '.$osC_Language->get('کدپیگیری : ').$_POST['rrn'];
						osC_Order :: process($this->_order_id, $this->order_status, $comments);
					}
					else 
					{

						$order = $this->_order_id;
						$orderid = $order;
						$reversaltoreversal = $order;
						$reversalstatus = 1;
						$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1  ( orders_id = '$order' )");
						osC_Order :: remove($this->_order_id);
						$messageStack->add_session('checkout','مبلغ واریزی با قیمت محصول برابر نیست.', 'error');
						osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
						}
				}
				else 
				{
					switch($result['ReturnId'])
					{
						case '-1' : $err = 'تراکنش پیدا نشد';break;
						case '-2' : $err = 'تراکنش قبلا Reverse شده است';break;
						case '-3' : $err = 'خطا عمومی';break;
						case '-4' : $err = 'امکان انجام درخواست برای این تراکنش وجود ندارد';break;
						case '-5' : $err = 'آدرس IP پذیرنده نامعتبر است';break;
						default  : $err = 'خطای ناشناس : '.$result['ReturnId'];break;
						
					}
					$order = $this->_order_id;
					$orderid = $order;
					$reversaltoreversal = $order;
					$reversalstatus = 1;
					$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1  ( orders_id = '$order' )");
					osC_Order :: remove($this->_order_id);
					$messageStack->add_session('checkout', $err, 'error');
					osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
				}
				
			}
			else 
			{
				$order = $this->_order_id;
				$orderid = $order;
				$reversaltoreversal = $order;
				$reversalstatus = 1;
				$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1  ( orders_id = '$order' )");
				osC_Order :: remove($this->_order_id);
				$errorname = 'برگشت ناموفق از درگاه';
				$messageStack->add_session('checkout', 'رسید قبلا استفاده شده است' , 'error');
				osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
		    }
		}
		else {
	        $order = $this->_order_id;
			$orderid = $order;
			$reversaltoreversal = $order;
			$reversalstatus = 1;
			$osC_Database->simpleQuery("delete from `" . DB_TABLE_PREFIX . "online_transactions` where 1  ( orders_id = '$order' )");
			osC_Order :: remove($this->_order_id);
			$errorname = 'برگشت ناموفق از درگاه';
			$messageStack->add_session('checkout', 'در عملیات پرداخت خطا رخ داده است : <b>'.$_POST['respmsg'].'</b>' , 'error');
			osc_redirect(osc_href_link(FILENAME_CHECKOUT, 'checkout&view=paymentInformationForm', 'SSL', null, null, true));
		    }
	}

	function callback() {
		global $osC_Database;
		//
	}

}
?>